<?php
/*
 * Copyright (c) 2025 AltumCode (https://altumcode.com/)
 *
 * This software is licensed exclusively by AltumCode and is sold only via https://altumcode.com/.
 * Unauthorized distribution, modification, or use of this software without a valid license is not permitted and may be subject to applicable legal actions.
 *
 * 🌍 View all other existing AltumCode projects via https://altumcode.com/
 * 📧 Get in touch for support or general queries via https://altumcode.com/contact
 * 📤 Download the latest version via https://altumcode.com/downloads
 *
 * 🐦 X/Twitter: https://x.com/AltumCode
 * 📘 Facebook: https://facebook.com/altumcode
 * 📸 Instagram: https://instagram.com/altumcode
 */

namespace Altum\Models;

defined('ALTUMCODE') || die();

class Menu extends Model {

    public function get_menu_by_store_id_and_url($store_id, $url) {

        /* Get the menu */
        $post = null;

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('menu?store_id=' . $store_id . '&url=' . md5($url));

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $post = database()->query("SELECT * FROM `menus` WHERE `store_id` = {$store_id} AND `url` = '{$url}'")->fetch_object() ?? null;

            cache()->save(
                $cache_instance->set($post)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $post = $cache_instance->get();

        }

        return $post;

    }

    public function get_menus_by_store_id($store_id) {

        /* Get the store posts */
        $menus = [];

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('r_menus?store_id=' . $store_id);

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $menus_result = database()->query("
                SELECT 
                    *
                FROM 
                    `menus` 
                WHERE 
                    `store_id` = {$store_id}
                    AND `is_enabled` = 1
                ORDER BY `order`
            ");
            while($row = $menus_result->fetch_object()) $menus[] = $row;

            cache()->save(
                $cache_instance->set($menus)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $menus = $cache_instance->get();

        }

        return $menus;

    }

}
